<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::server_iostream Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1server__iostream.html">server_iostream</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pri-types">Private Types</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#pri-static-attribs">Static Private Attributes</a> &#124;
<a href="classdlib_1_1server__iostream-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::server_iostream Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::server_iostream:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1server__iostream.png" usemap="#dlib::server_5Fiostream_map" alt=""/>
  <map id="dlib::server_5Fiostream_map" name="dlib::server_5Fiostream_map">
<area href="classdlib_1_1server.html" alt="dlib::server" shape="rect" coords="0,0,129,24"/>
<area href="classdlib_1_1server__http.html" alt="dlib::server_http" shape="rect" coords="0,112,129,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a6d05378cd6dc3cae67ab0182e7d868b3"><td class="memItemLeft" align="right" valign="top"><a id="a6d05378cd6dc3cae67ab0182e7d868b3"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>shutdown_connection</b> (<a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a> id)</td></tr>
<tr class="separator:a6d05378cd6dc3cae67ab0182e7d868b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-types"></a>
Private Types</h2></td></tr>
<tr class="memitem:a7c6eeb5f7cb4ea7ea597698971986cb2"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1map.html">map</a>&lt; <a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>, <a class="el" href="classdlib_1_1connection.html">connection</a> *, <a class="el" href="classdlib_1_1memory__manager.html">memory_manager</a>&lt; char &gt;::kernel_2a &gt;::kernel_1b&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1server__iostream.html#a7c6eeb5f7cb4ea7ea597698971986cb2">id_map</a></td></tr>
<tr class="separator:a7c6eeb5f7cb4ea7ea597698971986cb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a3814f713d9fc2721b570b0f944eb0d34"><td class="memItemLeft" align="right" valign="top"><a id="a3814f713d9fc2721b570b0f944eb0d34"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>on_connect</b> (std::istream &amp;in, std::ostream &amp;out, const std::string &amp;foreign_ip, const std::string &amp;local_ip, unsigned short foreign_port, unsigned short local_port, <a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a> connection_id)=0</td></tr>
<tr class="separator:a3814f713d9fc2721b570b0f944eb0d34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a463dccfd93b124cd51aa60da9d7b7398"><td class="memItemLeft" align="right" valign="top"><a id="a463dccfd93b124cd51aa60da9d7b7398"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>on_connect</b> (<a class="el" href="classdlib_1_1connection.html">connection</a> &amp;con)</td></tr>
<tr class="separator:a463dccfd93b124cd51aa60da9d7b7398"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:ac2d06cfd53c757a31e877da1e4e0a470"><td class="memItemLeft" align="right" valign="top"><a id="ac2d06cfd53c757a31e877da1e4e0a470"></a>
<a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>&#160;</td><td class="memItemRight" valign="bottom"><b>next_id</b></td></tr>
<tr class="separator:ac2d06cfd53c757a31e877da1e4e0a470"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a432b178c1b2efb65334162fe1e2ced08"><td class="memItemLeft" align="right" valign="top"><a id="a432b178c1b2efb65334162fe1e2ced08"></a>
<a class="el" href="classdlib_1_1server__iostream.html#a7c6eeb5f7cb4ea7ea597698971986cb2">id_map</a>&#160;</td><td class="memItemRight" valign="bottom"><b>con_map</b></td></tr>
<tr class="separator:a432b178c1b2efb65334162fe1e2ced08"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a567054f502069922263fa2f4ba0d07c7"><td class="memItemLeft" align="right" valign="top"><a id="a567054f502069922263fa2f4ba0d07c7"></a>
<a class="el" href="classdlib_1_1mutex.html">mutex</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m</b></td></tr>
<tr class="separator:a567054f502069922263fa2f4ba0d07c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-static-attribs"></a>
Static Private Attributes</h2></td></tr>
<tr class="memitem:ac4e276fb4b3f62bad595316bf7828f29"><td class="memItemLeft" align="right" valign="top"><a id="ac4e276fb4b3f62bad595316bf7828f29"></a>
static const <a class="el" href="classdlib_1_1logger.html">logger</a>&#160;</td><td class="memItemRight" valign="bottom"><b>_dLog</b></td></tr>
<tr class="separator:ac4e276fb4b3f62bad595316bf7828f29"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classdlib_1_1server"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1server')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1server.html">dlib::server</a></td></tr>
<tr class="memitem:a0b5a2a67523277c871759c4fba581edc inherit pub_types_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a0b5a2a67523277c871759c4fba581edc"></a>
typedef <a class="el" href="classdlib_1_1server.html">server</a>&#160;</td><td class="memItemRight" valign="bottom"><b>kernel_1a</b></td></tr>
<tr class="separator:a0b5a2a67523277c871759c4fba581edc inherit pub_types_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1755869013a7e2b86e4f0f17855e8b9d inherit pub_types_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a1755869013a7e2b86e4f0f17855e8b9d"></a>
typedef <a class="el" href="classdlib_1_1server.html">server</a>&#160;</td><td class="memItemRight" valign="bottom"><b>kernel_1a_c</b></td></tr>
<tr class="separator:a1755869013a7e2b86e4f0f17855e8b9d inherit pub_types_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e4cbfe78397956e2f8e589c27aa28c9 inherit pub_types_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a5e4cbfe78397956e2f8e589c27aa28c9"></a>
typedef <a class="el" href="classdlib_1_1server__iostream.html">server_iostream</a>&#160;</td><td class="memItemRight" valign="bottom"><b>iostream_1a</b></td></tr>
<tr class="separator:a5e4cbfe78397956e2f8e589c27aa28c9 inherit pub_types_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab34a9a9b73c1c514a323db90571b388b inherit pub_types_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="ab34a9a9b73c1c514a323db90571b388b"></a>
typedef <a class="el" href="classdlib_1_1server__iostream.html">server_iostream</a>&#160;</td><td class="memItemRight" valign="bottom"><b>iostream_1a_c</b></td></tr>
<tr class="separator:ab34a9a9b73c1c514a323db90571b388b inherit pub_types_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5863d688e2e0b8d38e3ef3ec021550de inherit pub_types_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a5863d688e2e0b8d38e3ef3ec021550de"></a>
typedef <a class="el" href="classdlib_1_1server__http.html">server_http</a>&#160;</td><td class="memItemRight" valign="bottom"><b>http_1a</b></td></tr>
<tr class="separator:a5863d688e2e0b8d38e3ef3ec021550de inherit pub_types_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46aa35cac6e2689aee96dc7f26f7da2c inherit pub_types_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a46aa35cac6e2689aee96dc7f26f7da2c"></a>
typedef <a class="el" href="classdlib_1_1server__http.html">server_http</a>&#160;</td><td class="memItemRight" valign="bottom"><b>http_1a_c</b></td></tr>
<tr class="separator:a46aa35cac6e2689aee96dc7f26f7da2c inherit pub_types_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classdlib_1_1server"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classdlib_1_1server')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classdlib_1_1server.html">dlib::server</a></td></tr>
<tr class="memitem:a6618634e8c31b41b488a31b5f1ace261 inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a6618634e8c31b41b488a31b5f1ace261"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a6618634e8c31b41b488a31b5f1ace261 inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f54eb1f71b82f41ac0d21dcc2d1643d inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a3f54eb1f71b82f41ac0d21dcc2d1643d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>start</b> ()</td></tr>
<tr class="separator:a3f54eb1f71b82f41ac0d21dcc2d1643d inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33859305a1f288c04d679d32cd5fbf26 inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a33859305a1f288c04d679d32cd5fbf26"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_running</b> () const</td></tr>
<tr class="separator:a33859305a1f288c04d679d32cd5fbf26 inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f461593134d2dbc80b3a7dd8896a198 inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a4f461593134d2dbc80b3a7dd8896a198"></a>
const std::string&#160;</td><td class="memItemRight" valign="bottom"><b>get_listening_ip</b> () const</td></tr>
<tr class="separator:a4f461593134d2dbc80b3a7dd8896a198 inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a545eeee829a544cad8c15bde0989c110 inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a545eeee829a544cad8c15bde0989c110"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>get_listening_port</b> () const</td></tr>
<tr class="separator:a545eeee829a544cad8c15bde0989c110 inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab0f5b0126f3d8a63a405ef9a8b3366a6 inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="ab0f5b0126f3d8a63a405ef9a8b3366a6"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_listening_port</b> (int port)</td></tr>
<tr class="separator:ab0f5b0126f3d8a63a405ef9a8b3366a6 inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9942ea84b9b86138bbfe9477af41d51c inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a9942ea84b9b86138bbfe9477af41d51c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_listening_ip</b> (const std::string &amp;ip)</td></tr>
<tr class="separator:a9942ea84b9b86138bbfe9477af41d51c inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af49406a2430839b199fa1901dfef782d inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="af49406a2430839b199fa1901dfef782d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_max_connections</b> (int max)</td></tr>
<tr class="separator:af49406a2430839b199fa1901dfef782d inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf2e99ff3122c98a426905e5fd1e7fb4 inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="acf2e99ff3122c98a426905e5fd1e7fb4"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>get_max_connections</b> () const</td></tr>
<tr class="separator:acf2e99ff3122c98a426905e5fd1e7fb4 inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1c6fca558d9de379e8839b118b0266b9 inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a1c6fca558d9de379e8839b118b0266b9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>start_async</b> ()</td></tr>
<tr class="separator:a1c6fca558d9de379e8839b118b0266b9 inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a777439a8f9cc910de8750fea9490a05c inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="a777439a8f9cc910de8750fea9490a05c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>set_graceful_close_timeout</b> (unsigned long <a class="el" href="classdlib_1_1timeout.html">timeout</a>)</td></tr>
<tr class="separator:a777439a8f9cc910de8750fea9490a05c inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad811e894cfdde0996208b29497576263 inherit pub_methods_classdlib_1_1server"><td class="memItemLeft" align="right" valign="top"><a id="ad811e894cfdde0996208b29497576263"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>get_graceful_close_timeout</b> () const</td></tr>
<tr class="separator:ad811e894cfdde0996208b29497576263 inherit pub_methods_classdlib_1_1server"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a7c6eeb5f7cb4ea7ea597698971986cb2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7c6eeb5f7cb4ea7ea597698971986cb2">&#9670;&nbsp;</a></span>id_map</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="classdlib_1_1map.html">map</a>&lt;<a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">uint64</a>,<a class="el" href="classdlib_1_1connection.html">connection</a>*,<a class="el" href="classdlib_1_1memory__manager.html">memory_manager</a>&lt;char&gt;::kernel_2a&gt;::kernel_1b <a class="el" href="classdlib_1_1server__iostream.html#a7c6eeb5f7cb4ea7ea597698971986cb2">dlib::server_iostream::id_map</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">INITIAL VALUE
    - next_id == 0
    - con_map.size() == 0

CONVENTION
    - next_id == the id of the next connection 
    - for all current connections
        - con_map[id] == the connection object with the given id
    - m == the mutex that protects the members of this object
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="server__iostream_8h_source.html">server_iostream.h</a></li>
<li>server_iostream.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
